/**
 * Redistribution and use of this software and associated documentation
 * ("Software"), with or without modification, are permitted provided
 * that the following conditions are met:
 *
 * 1. Redistributions of source code must retain copyright
 *    statements and notices.  Redistributions must also contain a
 *    copy of this document.
 *
 * 2. Redistributions in binary form must reproduce the
 *    above copyright notice, this list of conditions and the
 *    following disclaimer in the documentation and/or other
 *    materials provided with the distribution.
 *
 * 3. The name "Exolab" must not be used to endorse or promote
 *    products derived from this Software without prior written
 *    permission of Exoffice Technologies.  For written permission,
 *    please contact info@exolab.org.
 *
 * 4. Products derived from this Software may not be called "Exolab"
 *    nor may "Exolab" appear in their names without prior written
 *    permission of Exoffice Technologies. Exolab is a registered
 *    trademark of Exoffice Technologies.
 *
 * 5. Due credit should be given to the Exolab Project
 *    (http://www.exolab.org/).
 *
 * THIS SOFTWARE IS PROVIDED BY EXOFFICE TECHNOLOGIES AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
 * EXOFFICE TECHNOLOGIES OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Copyright 1999 (C) Exoffice Technologies Inc. All Rights Reserved.
 *
 * $Id: RiBinding.java,v 1.2 2002/02/25 20:30:54 dblevins Exp $
 */


package org.openejb.ri.server;

import java.util.HashMap;
import java.util.Vector;
import org.openejb.Container;
import org.openejb.DeploymentInfo;
import org.openejb.util.proxy.ProxyManager;

/*
*
*
* @author David Blevins
* @author Richard Monson-Haefel
* @author Aaron Mulder (ammulder@alumni.princeton.edu)
*/

public class RiBinding {

    protected DeploymentInfo deploymentInfo;
    protected Container container;
    protected Class ejbHome;
    protected Class ejbObject;
    String jndiName;

    public RiBinding(Container cont, DeploymentInfo deployInfo, String jndiNm, Class home, Class object) {
        container = cont;
        deploymentInfo = deployInfo;
        ejbHome = home;
        ejbObject = object;
        jndiName = jndiNm;
    }

    public Container getContainer() {
        return container;
    }

    public DeploymentInfo getDeploymentInfo() {
        return deploymentInfo;
    }

    public Object getEJBHome( ) {
        try {
            return ProxyManager.newProxyInstance(ejbHome);
        } catch ( Exception e ) {
            throw new RuntimeException();
        }
    }
    public void setEJBHome(Class home) {
        ejbHome = home;
    }
    public Object getEJBObject( ) {
        try {
            return ejbObject.newInstance();
        } catch ( Exception e ) {
            throw new RuntimeException();
        }

    }
    public void setEJBObject(Class c) {
        ejbObject = c;
    }
    public String getJndiName( ) {
        return jndiName;
    }

}
