/**
 * Redistribution and use of this software and associated documentation
 * ("Software"), with or without modification, are permitted provided
 * that the following conditions are met:
 *
 * 1. Redistributions of source code must retain copyright
 *    statements and notices.  Redistributions must also contain a
 *    copy of this document.
 *
 * 2. Redistributions in binary form must reproduce the
 *    above copyright notice, this list of conditions and the
 *    following disclaimer in the documentation and/or other
 *    materials provided with the distribution.
 *
 * 3. The name "OpenEJB" must not be used to endorse or promote
 *    products derived from this Software without prior written
 *    permission of The OpenEJB Group.  For written permission,
 *    please contact openejb-group@openejb.sf.net.
 *
 * 4. Products derived from this Software may not be called "OpenEJB"
 *    nor may "OpenEJB" appear in their names without prior written
 *    permission of The OpenEJB Group. OpenEJB is a registered
 *    trademark of The OpenEJB Group.
 *
 * 5. Due credit should be given to the OpenEJB Project
 *    (http://openejb.sf.net/).
 *
 * THIS SOFTWARE IS PROVIDED BY THE OPENEJB GROUP AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
 * THE OPENEJB GROUP OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Copyright 2001 (C) The OpenEJB Group. All Rights Reserved.
 *
 * $Id: OpenEjbTestServer.java,v 1.3 2002/09/06 04:38:33 dblevins Exp $
 */
package org.openejb.test;

import java.util.Properties;
import javax.naming.Context;
import java.io.OutputStream;
import java.net.Socket;

/**
 * 
 * @author <a href="mailto:david.blevins@visi.com">David Blevins</a>
 */
public class OpenEjbTestServer implements org.openejb.test.TestServer {
    
    static{
        System.setProperty("noBanner", "true");
    }
    
    private Properties properties;
    
    public void init(Properties props){
        properties = props;
    }
    
    public void destroy(){
    }
    
    public void start(){
        if (!connect()) {
            throw new RuntimeException("Cannot connect to the server.");
        }
    }

    public void stop(){
        try{
            
        Socket socket = new Socket("localhost", 4201);
        OutputStream out = socket.getOutputStream();
        
        out.write( "Stop".getBytes() );
                
        } catch (Exception e){
            e.printStackTrace();
        }
    }

    public Properties getContextEnvironment(){
        return (Properties)properties.clone();
    }

    private boolean connect() {
        return connect( 0 );
    }
    
    private boolean connect(int tries) {
        try{
            Socket socket = new Socket("localhost", 4200);
            OutputStream out = socket.getOutputStream();
        } catch (Exception e){
            
            if ( tries > 5 ) {
                return false;
            } else {
                try{
                    Thread.sleep(5000);
                } catch (Exception e2){
                    e.printStackTrace();
                }
                return connect(++tries);
            }
        }
        
        return true;
    }

}
